## ros-noetic-exotica-pinocchio-dynamics-solver 6.2.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.2)
project(exotica_pinocchio_dynamics_solver)

# Set clang as compiler
if(NOT CMAKE_CXX_COMPILER)
  set(CMAKE_CXX_COMPILER clang++)
endif()
if(NOT CMAKE_C_COMPILER)
  set(CMAKE_C_COMPILER clang)
endif()

find_package(catkin REQUIRED COMPONENTS
  exotica_core
  roscpp
)

find_package(pinocchio REQUIRED)

AddInitializer(
  pinocchio_dynamics_solver
  pinocchio_gravity_compensation_dynamics_solver
)
GenInitializers()

catkin_package(
  INCLUDE_DIRS include
  LIBRARIES ${PROJECT_NAME}
  CATKIN_DEPENDS exotica_core
  DEPENDS pinocchio
)

include_directories(
  include
  ${catkin_INCLUDE_DIRS}
)

add_library(${PROJECT_NAME}
  src/pinocchio_dynamics_solver.cpp
  src/pinocchio_dynamics_solver_assign_scene.cpp
  src/pinocchio_dynamics_solver_derivatives.cpp
  src/pinocchio_dynamics_solver_inverse_dynamics.cpp
  src/pinocchio_gravity_compensation_dynamics_solver.cpp
  src/pinocchio_gravity_compensation_dynamics_solver_assign_scene.cpp
  src/pinocchio_gravity_compensation_dynamics_solver_derivatives.cpp
)
target_compile_options(${PROJECT_NAME} PRIVATE -Wno-deprecated -Wno-variadic-macros -Wno-deprecated-declarations -Wno-comment -Wno-ignored-attributes)
target_link_libraries(${PROJECT_NAME} PUBLIC pinocchio::pinocchio)
add_dependencies(${PROJECT_NAME} ${PROJECT_NAME}_initializers ${catkin_EXPORTED_TARGETS})

install(TARGETS ${PROJECT_NAME}
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
  FILES_MATCHING PATTERN "*.h"
)

install(FILES
  exotica_plugins.xml
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)

=== debian/changelog ===
ros-noetic-exotica-pinocchio-dynamics-solver (6.2.0-1buster) buster; urgency=high

  * Use clang for Pinocchio dynamics solver (#746 <https://github.com/ipab-slmc/exotica/issues/746>)
  * Contributors: Wolfgang Merkt

 -- Wolfgang Merkt <wolfgang@robots.ox.ac.uk>  Thu, 22 Jul 2021 23:00:00 -0000

ros-noetic-exotica-pinocchio-dynamics-solver (6.1.1-1buster) buster; urgency=high

  * Reduce compilation time and required memory
  * Contributors: Wolfgang Merkt

 -- Wolfgang Merkt <wolfgang@robots.ox.ac.uk>  Sun, 04 Apr 2021 23:00:00 -0000

ros-noetic-exotica-pinocchio-dynamics-solver (6.1.0-1buster) buster; urgency=high



 -- Wolfgang Merkt <wolfgang@robots.ox.ac.uk>  Mon, 15 Mar 2021 00:00:00 -0000

ros-noetic-exotica-pinocchio-dynamics-solver (6.0.2-1buster) buster; urgency=high

  * Split derivatives into separate compile units to reduce memory consumption (7.6 GB peak to 6.1 GB peak) (#729 <https://github.com/ipab-slmc/exotica/issues/729>)
  * Contributors: Wolfgang Merkt

 -- Wolfgang Merkt <wolfgang@robots.ox.ac.uk>  Mon, 23 Nov 2020 00:00:00 -0000

ros-noetic-exotica-pinocchio-dynamics-solver (6.0.1-1buster) buster; urgency=high



 -- Wolfgang Merkt <wolfgang@robots.ox.ac.uk>  Tue, 17 Nov 2020 00:00:00 -0000

ros-noetic-exotica-pinocchio-dynamics-solver (6.0.0-1buster) buster; urgency=high

  * Add state transition function, derivative.
  * Support explicit Euler and semi-implicit Euler integration schemes
  * CMakeLists: Upgrade minimum version to 3.0.2 to avoid CMP0048
  * Fix Pinocchio packaging (for later versions)
  * Add dynamics solver with gravity compensation
  * Fix analytic derivatives and remove memory allocation during the computation
  * Contributors: Wolfgang Merkt

 -- Wolfgang Merkt <wolfgang@robots.ox.ac.uk>  Sun, 08 Nov 2020 00:00:00 -0000

ros-noetic-exotica-pinocchio-dynamics-solver (5.1.3-1buster) buster; urgency=high



 -- Wolfgang Merkt <wolfgang@robots.ox.ac.uk>  Thu, 13 Feb 2020 00:00:00 -0000

ros-noetic-exotica-pinocchio-dynamics-solver (5.1.2-1buster) buster; urgency=high



 -- Wolfgang Merkt <wolfgang@robots.ox.ac.uk>  Mon, 10 Feb 2020 00:00:00 -0000

ros-noetic-exotica-pinocchio-dynamics-solver (5.1.1-1buster) buster; urgency=high



 -- Wolfgang Merkt <wolfgang@robots.ox.ac.uk>  Mon, 10 Feb 2020 00:00:00 -0000

ros-noetic-exotica-pinocchio-dynamics-solver (5.1.0-1buster) buster; urgency=high

  * Added exotica_pinocchio_dynamics_solver

 -- Wolfgang Merkt <wolfgang@robots.ox.ac.uk>  Fri, 31 Jan 2020 00:00:00 -0000

=== debian/control ===
Source: ros-noetic-exotica-pinocchio-dynamics-solver
Section: misc
Priority: optional
Maintainer: Wolfgang Merkt <wolfgang@robots.ox.ac.uk>
Build-Depends: debhelper (>= 9.0.0), clang, ros-noetic-catkin, ros-noetic-exotica-core, ros-noetic-pinocchio, ros-noetic-roscpp
Homepage: 
Standards-Version: 3.9.2

Package: ros-noetic-exotica-pinocchio-dynamics-solver
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, clang, ros-noetic-exotica-core, ros-noetic-pinocchio, ros-noetic-roscpp
Description: Dynamics solver plug-in using Pinocchio for Exotica

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/noetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/noetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/noetic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-noetic-exotica-pinocchio-dynamics-solver//opt/ros/noetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_install
